Subject: Re: [Bitcoin-development] Ultimate Blockchain Compression w/ trust-free lite node

From: Gregory Maxwell <[email-masked]>
Date: Tue, 19 Jun 2012 13:59:04 -0400

On Tue, Jun 19, 2012 at 1:33 PM, Alan Reiner <[email-masked]> wrote:
> One app developer updates their
> RB tree code which updated the RB-tree optimizations/rebalancing, and
> now a significant portion of the network can't agree on the correct
> root.  Not only would that be disruptive, it would be a disaster to
> track down.

This is why good comprehensive tests and a well specified algorithim
are important. The tree update algorithm would be normative in that
scheme. Worrying that implementers might get it wrong would be like
worrying that they'd get SHA256 wrong.

> A PATRICIA tree/trie would be ideal, in my mind, as it also has a
> completely deterministic structure, and is an order-of-magnitude more

Provable libJudy trees. Oh boy.